package com.lzmispt.data.resource.service.etldevelop.impl;

package .tmp;

import com.lzmispt.data.center.entity.dto.resource.apply.GetApplyEntityInfoVO;
import com.lzmispt.data.center.entity.dto.resource.etl.GetEtlTableInfoDTO;
import com.lzmispt.data.center.entity.vo.resource.etl.TableInfoForEtlVO;
import com.lzmispt.data.center.entity.vo.resource.metadata.MetadataEntityInfoItemVO;
import com.lzmispt.data.center.entity.vo.resource.metadata.MetadataEntityVO;
import com.lzmispt.data.center.entity.vo.standard.codetable.MetadataCommonCodeVO;
import com.lzmispt.data.resource.client.DataApplyClient;
import com.lzmispt.data.resource.client.DataStandardClient;
import com.lzmispt.data.resource.dao.metadata.IMetadataDao;
import com.lzmispt.data.resource.entity.po.metadata.MetadataEntityInfoItemPO;
import com.lzmispt.data.resource.entity.po.metadata.MetadataEntityPO;
import com.lzmispt.data.resource.service.etldevelop.IEtlApi;
import com.lzmispt.data.resource.service.metadata.IApplyService;
import com.lzmispt.dcbase.ServiceUtil;
import com.lzmispt.dcbase.dcconst.DCConst;
import com.lzmispt.dcbase.sysfield.SysFieldHelper;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

@Service
public class EtlApiImpl implements IEtlApi {
  @Autowired
  DataStandardClient dataStandardClient;
  
  @Autowired
  DataApplyClient dataApplyClient;
  
  @Autowired
  private IApplyService applyService;
  
  public TableInfoForEtlVO getTableInfoByDataSourceIdAndTableName(GetEtlTableInfoDTO param, String platCode) {
    MetadataEntityVO entityVO;
    List<MetadataEntityInfoItemVO> infoItemVOs;
    if ("Apply".equalsIgnoreCase(platCode)) {
      try {
        GetApplyEntityInfoVO obj = (GetApplyEntityInfoVO)this.dataApplyClient.getTableInfoByDataSourceIdAndTableName(param, "0").getObj();
        if (obj == null)
          return null; 
        entityVO = this.applyService.parseMetadataEntity(obj.getEntityInfo());
        infoItemVOs = new ArrayList<>();
        obj.getFieldList().forEach(item -> infoItemVOs.add(this.applyService.parseEntityFieldInfo(item)));
        if (infoItemVOs.isEmpty())
          return null; 
      } catch (Exception ignored) {
        return null;
      } 
    } else {
      IMetadataDao metadataDao = (IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class);
      List<MetadataEntityPO> entityList = metadataDao.selectEntitysByDataSourceIdAndTableName(param.getDataSourceId(), param.getTableName());
      if (entityList.isEmpty())
        return null; 
      entityVO = new MetadataEntityVO();
      BeanUtils.copyProperties(entityList.get(0), entityVO);
      infoItemVOs = new ArrayList<>();
      metadataDao.getEntityInfoItemsByEntityId(entityVO.getEntityId()).forEach(item -> {
            MetadataEntityInfoItemVO infoItemVO = new MetadataEntityInfoItemVO();
            BeanUtils.copyProperties(item, infoItemVO);
            infoItemVOs.add(infoItemVO);
          });
      if (infoItemVOs.isEmpty())
        return null; 
    } 
    return getTableInfoForEtlVO(platCode, entityVO, infoItemVOs);
  }
  
  private TableInfoForEtlVO getTableInfoForEtlVO(String platCode, MetadataEntityVO entityVO, List<MetadataEntityInfoItemVO> infoItemVOs) {
    TableInfoForEtlVO tableInfoVO = new TableInfoForEtlVO();
    Map<Long, List<String>> codeTableIdDataItemNameMap = new HashMap<>();
    List<String> businessKey = new ArrayList<>();
    for (MetadataEntityInfoItemVO entityInfoItem : infoItemVOs) {
      if (SysFieldHelper.sysFieldContains(entityInfoItem.getDataItemName()))
        continue; 
      if (entityInfoItem.getDataRange() != null)
        ((List<String>)codeTableIdDataItemNameMap.computeIfAbsent(entityInfoItem.getDataRange(), key -> new ArrayList())).add(entityInfoItem.getDataItemName()); 
      if (DCConst.TRUE.equals(entityInfoItem.getIsPrimaryKey()))
        businessKey.add(entityInfoItem.getDataItemName()); 
    } 
    Set<Long> codeTableIds = codeTableIdDataItemNameMap.keySet();
    Map<String, String> fieldBelongCodeTable = new HashMap<>();
    if (!codeTableIds.isEmpty()) {
      List<MetadataCommonCodeVO> codeTables = (List<MetadataCommonCodeVO>)this.dataStandardClient.getMetadataCommonCodeByIds(new ArrayList<>(codeTableIds), platCode, "0").getObj();
      if (!CollectionUtils.isEmpty(codeTables))
        for (MetadataCommonCodeVO codeTable : codeTables) {
          List<String> list = codeTableIdDataItemNameMap.get(codeTable.getCodeTableId());
          list.forEach(item -> (String)fieldBelongCodeTable.put(item, codeTable.getCode_table_identifier()));
        }  
    } 
    tableInfoVO.setEntity(entityVO);
    tableInfoVO.setInfoItems(infoItemVOs);
    tableInfoVO.setBusinessKeys(businessKey);
    tableInfoVO.setFieldBelongCodeTable(fieldBelongCodeTable);
    return tableInfoVO;
  }
}
